/* wb.h
 * Projet WhiteBoard: fichier en tete
 * Auteur : VOURIOT Thierry
 * Date : 27 decembre 2001
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <signal.h>
#include <unistd.h>

/* Intervalle de temps entre 2 refresh des afficheurs */
#define AFFICHEUR_TEMPO 10

/* Nombre maximun d'afficheurs geres par le serveur */
#define AFFICHEUR_NBMAX 10

/* Longueur maximum des tags */
#define TAGUEUR_LGMAX 500

/* Nombre de caracteres en longueur du mur */
#define MUR_LONGUEUR 80

/* Nombre de caracteres en hauteur du mur */
#define MUR_HAUTEUR 25

/* Nombre de caracteres total du mur */
#define MUR_TAILLE MUR_LONGUEUR * MUR_HAUTEUR

/* Structure en memoire partagee */
typedef struct SMurAffs
{
	/* Mur de caractres sous la forme d'un tableau */
	char mur[MUR_TAILLE];
	/* Pid du serveur */
	pid_t serveur;
	/* Pid des afficheurs */
	pid_t afficheurs[AFFICHEUR_NBMAX];
} MurAffs;
	

