/* wb_tagueur.c
 * Projet WhiteBoard: tagueur
 * Auteur : VOURIOT Thierry
 * Date : 27 decembre 2001
 */

#include "wb.h"

/* Fonction qui affiche un message d'erreur et quitte le programme */
void erreur(char *s)
{
	perror(s);
	exit(-1);
}

/* Vide le tampon associe a stdin */
void vide_stdin()
{
	char c = getchar();
	if (c != '\n')
		while ( (getchar()) !=  '\n');
}

/* Lecture d'une chaine de caractere */
void get_line(char *buf, size_t size) 
{
	int i = 0;
	char c;
	vide_stdin();
	while ((c = getchar()) != '\n' && i < size)
	{
		buf[i] = c;
		i++;
	}
	buf[i] = '\0';
	
}

/* Main: prend en entree des coordonnees (x,y) et un texte, puis affiche
 * le texte a cet endroit dans le mur en memoire partagee, et informe
 * le serveur de la modif par signal SIGTERM 
 */
int main(int argc, char **argv)
{
	MurAffs *smur;
	int id;
	key_t cle;
	int x,y;
	char tag[TAGUEUR_LGMAX];
	int i,c;

	if (argc != 2) {
		printf("Usage: wb_tagueur shmcle\n");
		return -1;
	}	
	if (sscanf(argv[1],"%d",&cle) == 0) {
		printf("Cle invalide: echec\n");
		return -1;
	}	
	if ((id = shmget(cle,sizeof(int),0)) == -1)
		erreur("Le segment de memoire specifie n'existe pas\n");

	if ((smur = (MurAffs *)shmat(id,0,0)) < 0)
		erreur("Erreur primitive shmat");
	
	printf("x = ");scanf("%d",&x);

	printf("y = ");scanf("%d",&y);		

	printf("Tag = ");get_line(tag,sizeof tag);

	c=0;
	for (i=(y-1)*MUR_LONGUEUR+(x-1);tag[c]!=0;i++)
	{
		if (i>=0 && i<2000)
			smur->mur[i] = tag[c];	
		c++;
	}

	if (kill(smur->serveur,SIGTERM) == -1)
		erreur("Erreur primitive kill");

	return 0;
}

	
